#include<htc.h>
#include"capture.h"


void init_capture()
{
	TRISCbits.TRISC5 = 1; //configure as input pin
	CCP1CON |= 0b0100; //Capture mode, every falling edge
	T1CON = 0x31; //1:8 prescaler & timer1 ON
	TMR1IE = 1; //Enables the TMR1 overflow interrupt
	CCP1IE = 1; //Enables the CCP1 interrupt
	PEIE = 1; //Enables all unmasked peripheral interrupts
	GIE = 1; //Enables all unmasked interrupts
}



void interrupt capture()
{
	static bit pulse_state = 0;	
 
	if(TMR1IF)
	{
		countrev = 0;
		TMR1IF = 0;
	}

	if(CCP1IF)
	{
		CCP1IF = 0;
		switch(pulse_state)
		{
			case 0: 
			TMR1L = 0;
			TMR1H = 0;
			pulse_state = 1;
			break;

			case 1:
			rpm_timer = TMR1L;            // Get the first 8-bit TIMER0 Counter
        	rpm_timer += (TMR1H << 8);    // Get the last 8-bit TIMER0 Counter
			countrev = (int) (60000.0 / (0.008 * rpm_timer ) );
			pulse_state = 0;
			

		}
		

	} 
		

}




